#include "hud.h"

void HUDClass::addcoin()
{
	coins++;
}

void HUDClass::init(int loc)
{
	location=loc;
	for(int i=0; i<8; i++)
		trophy[i]=0;

	dfont.LoadFromFile("files/digi.ttf", 64);
	number.SetFont(dfont);
	number.SetSize(16);
	thisBiome.SetFont(dfont);
	thisBiome.SetSize(16);
	thisBiome.SetText("Undefined");
	thisBiome.SetPosition(0, 0);
	image.LoadFromFile("files/sprites.png");
	image.SetSmooth(false);
	for(int j=0; j<8; j++)
	{
		biomes[j].SetImage(image);
		biomes[j].SetSubRect(sf::IntRect((j%4)*16, (j/4)*16+64, (j%4)*16+16, (j/4)*16+80));
		biomes[j].SetPosition(float(j*16), 16);
	}
	coin.SetImage(image);
	coin.SetSubRect(sf::IntRect(0, 0, 16, 16));
	coin.SetPosition(0, 32);
}

void HUDClass::render(sf::RenderWindow &win)
{
	char buf[16]="\0";
	sprintf_s(buf, sizeof(buf), "%i", coins);
	number.SetText(buf);
	number.SetPosition(16, 32);
	win.Draw(coin);
	win.Draw(number);
	win.Draw(thisBiome);
	for(int i=0; i<8; i++)
	{
		if(trophy[i]==1)
		{
			win.Draw(biomes[i]);
		}
	}

}

void HUDClass::setcoins(int cs)
{
	coins=cs;
}

void HUDClass::setbiome(int index)
{
	switch(index)
	{
	case 0:
		thisBiome.SetText("Volcano");
		break;
	case 1:
		thisBiome.SetText("Snowy Peak");
		break;
	case 2:
		thisBiome.SetText("Forest");
		break;
	case 3:
		thisBiome.SetText("Meadow");
		break;
	case 4:
		thisBiome.SetText("Deep Ocean");
		break;
	case 5:
		thisBiome.SetText("Island");
		break;
	case 6:
		thisBiome.SetText("Desert");
		break;
	case 7:
		thisBiome.SetText("Castle");
		break;
	default:
		thisBiome.SetText("Undefined");
		break;
	}

}

void HUDClass::cleartrophy()
{
	for(int i=0; i<8; i++)
		settrophy(i, false);
}

void HUDClass::settrophy(int index, bool isset)
{
	if(isset) trophy[index]=1; else trophy[index]=0;
}

bool HUDClass::allCollected()
{
	bool ret=true;
	for(int i=0; i<8; i++)
		if(trophy[i]==0) ret=false;

	return ret;
}


