#include "map.h"

MapClass::MapClass()
{

	init();
}

void MapClass::init()
{
	mainColor=sf::Color::Black;
	image.Create(16, 16, mainColor);
	image.SetSmooth(false);
	sprite.SetImage(image);
	int srlocx, srlocy, srdimx, srdimy;
	int spotx, spoty;
		srlocx=rand()%16+8;
		srlocy=rand()%4+6;
		srdimx=rand()%3+3;
		srdimy=rand()%3+3;

	for(int y=0; y<18; y++)
	{
		for(int x=0; x<32; x++)
		{
			tile[x][y].tileType=1;
			tile[x][y].alpha=255-rand()%25;
			tile[x][y].wall=true;
		}
	}
	
	//pick a starting room location and size
	while(!(srlocx>0 && srlocy>0 && srlocx+srdimx<32 && srlocy+srdimy<18))
	{
		srlocx=rand()%16+8;
		srlocy=rand()%4+6;
		srdimx=rand()%3+3;
		srdimy=rand()%3+3;
	}

	//make the starting room
	for(int by=srlocy; by<(srlocy+srdimy); by++)
	{
		for(int bx=srlocx; bx<(srlocx+srdimx); bx++)
		{
			tile[bx][by].alpha=rand()%32;
			tile[bx][by].wall=false;
		}
	}

	//pick a starting spot in the starting room
	spotx=rand()%srdimx+srlocx;
	spoty=rand()%srdimy+srlocy;
	treasurePosition=sf::Vector2f(float(spotx*16), float(spoty*16));

	currentRoom.x=srlocx;
	currentRoom.y=srlocy;
	currentRoom.w=srdimx;
	currentRoom.h=srdimy;


	for(int i=0; i<30; i++) makeroom(currentRoom);
	
	for(int fy=0; fy<17; fy++)
	{
		for(int fx=0; fx<31; fx++)
		{
			if((tile[fx][fy].wall && tile[fx+1][fy+1].wall && !tile[fx+1][fy].wall && !tile[fx][fy+1].wall)
				|| (!tile[fx][fy].wall && !tile[fx+1][fy+1].wall && tile[fx+1][fy].wall && tile[fx][fy+1].wall))
			{
				tile[fx][fy].alpha=rand()%32;
				tile[fx][fy].wall=false;
				tile[fx+1][fy].alpha=rand()%32;
				tile[fx+1][fy].wall=false;
				tile[fx][fy+1].alpha=rand()%32;
				tile[fx][fy+1].wall=false;
				tile[fx+1][fy+1].alpha=rand()%32;
				tile[fx+1][fy+1].wall=false;
			}
		}
	}
	PutTheHUD = 0;
	for(int hy=0; hy<6; hy++)
	{
		for(int hx=0; hx<6; hx++)
		{
			if(!tile[hx][hy].wall) PutTheHUD=1;
		}
	}
	if(PutTheHUD==0) return;
	for(int hy=12; hy<18; hy++)
	{
		for(int hx=0; hx<6; hx++)
		{
			if(!tile[hx][hy].wall) PutTheHUD=2;
		}
	}
	if(PutTheHUD==1) return;
	for(int hy=0; hy<6; hy++)
	{
		for(int hx=26; hx<32; hx++)
		{
			if(!tile[hx][hy].wall) PutTheHUD=3;
		}
	}
	if(PutTheHUD==2) return;
	for(int hy=12; hy<18; hy++)
	{
		for(int hx=26; hx<32; hx++)
		{
			if(!tile[hx][hy].wall) PutTheHUD=0;
		}
	}




}
bool MapClass::makeroom(WHRect& r)
{
	return makeroom(r.x, r.y, r.w, r.h);
}

bool MapClass::makeroom(int px, int py, int dx, int dy)
{
	if(dy<1) dy=1;
	if(dx<1) dx=1;
	int dir=rand()%4;
	int dimx=rand()%4+3;
	int dimy=rand()%4+3;
	if(rand()%5<3)
	{
		if(rand()%2==1) dimy=1; else dimx=1;
	}
	int cx=px;
	int cy=py;
	int attempt=0;
	while(!((dir==0 && cy-dimy>0 && cx+dimx+dx<32)
		|| (dir==1 && cx+dimx+dx<32 && cy+dimy+dy<18)
		|| (dir==2 && cx-dimx>0 && cy+dimy+dy<18)
		|| (dir==3 && cx-dimx>0 && cy-dimy>0)))
	{
		dir=rand()%4;
		dimx=rand()%4+3;
		dimy=rand()%4+3;
		if(rand()%5<3)
		{
			if(rand()%2==1) dimy=1; else dimx=1;
		}
		attempt++;
		if(attempt>100) return false;
	}

	switch(dir)
	{
	case 0://north
		cx=px+rand()%(dx+1)-1;
		cy=py-dimy;

		break;
	case 1://east
		cx=px+dx;
		cy=py+rand()%(dy+1)-1;

		break;
	case 2://south
		cx=px-rand()%(dimx+1)+1;
		cy=py+dy;

		break;
	case 3://west
		cx=px-dimx;
		cy=py-rand()%(dimy+1)+1;

		break;
	default://no direction
		cx=px;
		cy=py;

		break;
	}

	while(cy+dimy+dy>18) cy--;
	while(cx+dimx+dx>32) cx--;

	for(int y=cy; y<cy+dimy; y++)
	{
		for(int x=cx; x<cx+dimx; x++)
		{
			tile[x][y].alpha=rand()%32+32;
			tile[x][y].wall=false;
		}
	}
	currentRoom.x=cx;
	currentRoom.y=cy;
	currentRoom.w=dimx;
	currentRoom.h=dimy;
	return true;
}


void MapClass::render(sf::RenderWindow &win)
{
	image.Create(16, 16, mainColor);
	image.SetSmooth(false);
	sprite.SetImage(image);

	for(int y=0; y<18; y++)
	{
		for(int x=0; x<32; x++)
		{
			setsprite(x, y);
			win.Draw(sprite);
		}
	}
}

void MapClass::setcolor(sf::Color& col)
{
	mainColor=col;
}

void MapClass::setsprite(int tx, int ty)
{
	sprite.SetPosition(float(tx*16), float(ty*16));
	sprite.SetColor(sf::Color(mainColor.r, mainColor.g, mainColor.b, tile[tx][ty].alpha));
}

sf::Vector2f MapClass::getPlayer(WHRect &room)
{
	int x=room.x+rand()%room.w;
	int y=room.y+rand()%room.h;
	return sf::Vector2f(float(x*16), float(y*16));
}